;--------------------------------

!include "MUI.nsh"

!define NAME "XMF"
!define VERSION '2.2'
!define MUI_ICON "icons\xmfinstall.ico"
!define MUI_UNICON "icons\xmfuninstall.ico"  

;General

Name "XMF"
OutFile "XMF.exe"
BrandingText "${NAME} ${VERSION}"
CRCCheck on
XPStyle on

;Pages
  
!define MUI_WELCOMEFINISHPAGE_BITMAP "graphics\win.bmp"  
!define MUI_WELCOMEPAGE_TITLE "Welcome to ${NAME} ${VERSION} Setup Wizard"
!define MUI_WELCOMEPAGE_TEXT "This wizard will guide you through the installation of ${NAME} ${VERSION}\n$_CLICK"
  
;Default installation folder
InstallDir "$PROGRAMFILES\XMF\"
  
;Get installation folder from registry if available
;InstallDirRegKey HKCU "Software\Modern UI Test" ""

;--------------------------------
;Interface Settings

!define MUI_ABORTWARNING

;--------------------------------
;Pages

!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE "license\EPL.txt"
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
  
;--------------------------------
;Languages
 
!insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections


Section "XMF" SecXMF

SetOutPath "$INSTDIR"
File files\run.bat
File files\XMFDocs.url
File icons\xmf.ico
File /r /x .svn /x .project "..\com.ceteva.xmf.machine"
File /r /x .svn /x .project "..\com.ceteva.xmf.system"
File /r /x .svn /x .project "..\com.ceteva.xmf.examples"
WriteUninstaller "$INSTDIR\Uninstall.exe"

; Write Program

SetOutPath "$INSTDIR\XMF"
CreateDirectory "$SMPROGRAMS\XMF"

; Write XMF Shortcut

SetOutPath "$INSTDIR"
CreateShortcut "$SMPROGRAMS\XMF\XMF.lnk" "$INSTDIR\run.bat ." "" "$INSTDIR\xmf.ico"

; Write Documentation Link

CreateShortcut "$SMPROGRAMS\XMF\Documentation.lnk" "$INSTDIR\XMFDocs.url"

; Write Uninstall Shortcut

CreateShortcut "$SMPROGRAMS\XMF\Uninstall.lnk" "$INSTDIR\Uninstall.exe" 

SectionEnd

;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_SecXMF ${LANG_ENGLISH} "Install ${NAME} (required)"
  
  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecXMF} $(DESC_SecXMF)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Uninstaller Section

Section "Uninstall"
  RMDir /r "$INSTDIR"
  RMDir /r "$SMPROGRAMS\XMF"
SectionEnd