package com.ceteva.xmf.emf;

import java.util.LinkedList;
import java.util.List;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.operations.OperationHistoryFactory;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.domain.IEditingDomainProvider;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.commands.core.command.AbstractTransactionalCommand;
import org.eclipse.swt.widgets.Display;

import engine.Machine;

import threads.ThreadInitiator;

public class Initiator extends ThreadInitiator {
	
	private EObject object;
	
	private Thread thread;
	
	public Initiator(EObject object,Thread thread) {
		this.object = object;
		this.thread = thread;
	}
	
	public void start(Machine machine) {
		runUpdate((TransactionalEditingDomain)EditingDomainProvider.getEditingDomain(object),machine);
	}

	public void runUpdate(final TransactionalEditingDomain ed,final Machine machine) {

		// Create the command
		Runnable r = new Runnable() {
			public void run() {
				List affectedFiles = new LinkedList();
				AbstractTransactionalCommand command = new AbstractTransactionalCommand(ed,
						"Initializing diagram contents", affectedFiles) {

					protected CommandResult doExecuteWithResult(IProgressMonitor monitor, IAdaptable info)
							throws ExecutionException {
						machine.perform();
						return null;
					}
				};

				// Run the command

				try {
					OperationHistoryFactory.getOperationHistory().execute(command, new NullProgressMonitor(), null);
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
			}
		};
		try {
			Display display = org.eclipse.swt.widgets.Display.findDisplay(thread);
			if(display != null)
			    display.syncExec(r);
			else machine.perform();
		} catch (Throwable t) {
			t.printStackTrace();
		}
	}

}
